<?php

$nwords = array(    "zero", "unu", "doi", "trei", "patru", "cinci", "sase", "sapte",
                     "opt", "noua", "zece", "unsprezece", "doisprezece", "treisprezece",
                     "paisprezece", "cincisprezece", "saisprezece", "saptesprezece", "optsprezece",
                     "nouasprezece", "douazeci", 30 => "treizeci", 40 => "patruzeci",
                     50 => "cincizeci", 60 => "saizeci", 70 => "saptezeci", 80 => "optzeci",
                     90 => "nouazeci" );

function number_to_words ($x)
{
     global $nwords;
     if(!is_numeric($x))
     {
         $w = '#';
     }else if(fmod($x, 1) != 0)
     {
         $w = '#';
     }else{
         if($x < 0)
         {
             $w = 'minus ';
             $x = -$x;
         }else{
             $w = '';
         }
         if($x < 21)
         {
             $w .= $nwords[$x];
         }else if($x < 100)
         {
             $w .= $nwords[10 * floor($x/10)];
             $r = fmod($x, 10);
             if($r > 0)
             {
                 $w .= ' si '. $nwords[$r];
             }
         } else if($x < 1000)
         {
		if (floor($x/100) == 1)
		{
			$w .= ' o suta ';
		}
		else
		{
             		$w .= $nwords[floor($x/100)] .' sute';
             	}
             $r = fmod($x, 100);
             if($r > 0)
             {
                 $w .= ' '. number_to_words($r);
             }
         } else if($x < 1000000)
         {
         	if (floor($x/1000) == 1)
		{
			$w .= ' o mie ';
		}
		else
		{
             		$w .= number_to_words(floor($x/1000)) .' de mii';
             	}
             $r = fmod($x, 1000);
             if($r > 0)
             {
                 $w .= ' ';
                 if($r < 100)
                 {
                     $w .= ' ';
                 }
                 $w .= number_to_words($r);
             }
         } else {
             $w .= number_to_words(floor($x/1000000)) .' milion';
             $r = fmod($x, 1000000);
             if($r > 0)
             {
                 $w .= ' ';
                 if($r < 100)
                 {
                     $word .= ' ';
                 }
                 $w .= number_to_words($r);
             }
         }
     }
     return $w;
}

// demonstration

if(isset($_POST['num']))
{
     echo '
      '.htmlspecialchars($_POST['num']).' = '.number_to_words($_POST['num']).'<p>
     <a href="'.$_SERVER['PHP_SELF'].'">try again</a>';
}else{
     echo '
     <form method="post" action="'.$_SERVER['PHP_SELF'].'">
         <input type="text" name="num">
         <input type="submit" value="spell number">
     </form>';
}

?>